create or replace package itstar_apex_toolbox is
  -- Record for GPS coordinates
  type t_rec_gps_pos is record(
    name varchar2(200),
    lat  varchar2(50),
    lng  varchar2(50),
    img  varchar2(1000));

  -- Collection hold the GPS positions
  type t_tab_gps_pos is table of t_rec_gps_pos index by binary_integer;

  function get_multimarker_json_string(pi_rec_gps_base   in t_rec_gps_pos,
                                       pi_tab_gps_marker in t_tab_gps_pos)
    return varchar2;

end itstar_apex_toolbox;
/
create or replace package body itstar_apex_toolbox is

  function get_multimarker_json_string(pi_rec_gps_base   in t_rec_gps_pos,
                                       pi_tab_gps_marker in t_tab_gps_pos)
    return varchar2 is
    l_rec_gps t_rec_gps_pos;
    l_return  varchar2(32000);
    l_row     number := 0;
  begin
    if pi_tab_gps_marker.first is null then
      return(null);
    end if;
  
    l_return := '{"base":[' || chr(10) || '{' || '"name": "' ||
                pi_rec_gps_base.name || '", ' || '"lat": ' ||
                pi_rec_gps_base.lat || ', ' || '"lng": ' ||
                pi_rec_gps_base.lng || '}' || ']},' || chr(10);
  
    for i in 1 .. pi_tab_gps_marker.count loop
      l_row := l_row + 1;
      if l_row = 1 then
        l_return := l_return || '{"marker":[' || chr(10);
      else
        l_return := l_return || ',' || chr(10);
      end if;
      l_rec_gps := pi_tab_gps_marker(i);
    
      l_return := l_return || '{' || '"name": "' || l_rec_gps.name ||
                  '", "lat": ' || l_rec_gps.lat || ', "lng": ' ||
                  l_rec_gps.lng || ', "img": "' || l_rec_gps.img || '"' || '}';
    
    end loop;
  
    if l_row > 1 then
      l_return := l_return || ']}';
    end if;
  
    l_return := '{"gps":[' || chr(10) || l_return || chr(10) || ']}';
  
    return(l_return);
  
  end;

begin
  -- Initialization
  null;
end itstar_apex_toolbox;
/
